diff --git a/web/pgadmin/feature_tests/query_tool_tests.py b/web/pgadmin/feature_tests/query_tool_tests.py
index 88ea9e151..9252b93ca 100644
--- a/web/pgadmin/feature_tests/query_tool_tests.py
+++ b/web/pgadmin/feature_tests/query_tool_tests.py
@@ -658,18 +616,18 @@ SELECT 1, pg_sleep(300)"""
         query_op.click()
 
         self.page.find_by_css_selector(
-            QueryToolLocatorsCss.btn_execute_query).click()
+            QueryToolLocators.btn_execute_query_css).click()
 
         self.page.find_by_xpath("//*[@id='fetching_data']")
         self.page.find_by_css_selector(
-            QueryToolLocatorsCss.btn_cancel_query).click()
+            QueryToolLocators.btn_cancel_query).click()
         self.page.wait_for_query_tool_loading_indicator_to_disappear()
         self.page.click_tab('Messages')
-        self.page.find_by_xpath(
+        self.assertTrue(self.page.check_if_element_exist_by_xpath(
             '//div[contains(@class, "sql-editor-message") and '
             '(contains(string(), "canceling statement due to user request") '
             'or contains(string(), "Execution Cancelled!"))]'
-        )
+        ))
 
     def _supported_server_version(self):
         connection = test_utils.get_db_connection(
@@ -683,48 +641,33 @@ SELECT 1, pg_sleep(300)"""
         return connection.server_version > 90100
 
     def _query_tool_notify_statements(self):
-        wait = WebDriverWait(self.page.driver, 60)
-
         print("\n\tListen on an event... ", file=sys.stderr, end="")
-        self.page.fill_codemirror_area_with("LISTEN foo;")
-        self.page.find_by_css_selector(
-            QueryToolLocatorsCss.btn_execute_query).click()
-
-        self.page.wait_for_query_tool_loading_indicator_to_disappear()
+        self.page.execute_query("LISTEN foo;")
         self.page.click_tab('Messages')
 
-        wait.until(EC.text_to_be_present_in_element(
-            (By.CSS_SELECTOR, ".sql-editor-message"), "LISTEN")
-        )
+        self.assertTrue(self.page.check_if_element_exist_by_xpath(
+            QueryToolLocators.sql_editor_message.format('LISTEN')),
+            "LISTEN message does not displayed")
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("\tNotify event without data... ", file=sys.stderr, end="")
-        self.page.fill_codemirror_area_with("NOTIFY foo;")
-        self.page.find_by_css_selector(
-            QueryToolLocatorsCss.btn_execute_query).click()
-
-        self.page.wait_for_query_tool_loading_indicator_to_disappear()
+        self.page.execute_query("NOTIFY foo;")
         self.page.click_tab('Notifications')
-        wait.until(EC.text_to_be_present_in_element(
+        self.wait.until(EC.text_to_be_present_in_element(
             (By.CSS_SELECTOR, "td.channel"), "foo")
         )
         print("OK.", file=sys.stderr)
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
         print("\tNotify event with data... ", file=sys.stderr, end="")
         if self._supported_server_version():
-            self.page.fill_codemirror_area_with("SELECT pg_notify('foo', "
-                                                "'Hello')")
-            self.page.find_by_css_selector(
-                QueryToolLocatorsCss.btn_execute_query).click()
-
-            self.page.wait_for_query_tool_loading_indicator_to_disappear()
+            self.page.execute_query("SELECT pg_notify('foo', 'Hello')")
             self.page.click_tab('Notifications')
-            wait.until(WaitForAnyElementWithText(
+            self.wait.until(WaitForAnyElementWithText(
                 (By.CSS_SELECTOR, 'td.payload'), "Hello"))
             print("OK.", file=sys.stderr)
-            self._clear_query_tool()
+            self.page.clear_query_tool()
         else:
             print("Skipped.", file=sys.stderr)
 
@@ -756,69 +699,63 @@ SELECT 1, pg_sleep(300)"""
             is_edb = 'EnterpriseDB' in version_string[0]
 
         connection.close()
-
         return connection.server_version >= 110000 and jit_enabled
 
     def _query_tool_explain_check_jit_stats(self):
-        wait = WebDriverWait(self.page.driver, 10)
 
-        self.page.fill_codemirror_area_with("SET jit_above_cost=10;")
-        self.page.find_by_css_selector(
-            QueryToolLocatorsCss.btn_execute_query).click()
-        self.page.wait_for_query_tool_loading_indicator_to_disappear()
-        self._clear_query_tool()
+        self.page.execute_query("SET jit_above_cost=10;")
+        self.page.clear_query_tool()
 
         self.page.fill_codemirror_area_with("SELECT count(*) FROM pg_class;")
-
         explain_op = self.page.find_by_css_selector(
-            QueryToolLocatorsCss.btn_explain_options_dropdown)
+            QueryToolLocators.btn_explain_options_dropdown)
         explain_op.click()
 
         # disable Explain options and only enable COST option
-        for op in (QueryToolLocatorsCss.btn_explain_verbose,
-                   QueryToolLocatorsCss.btn_explain_costs,
-                   QueryToolLocatorsCss.btn_explain_buffers,
-                   QueryToolLocatorsCss.btn_explain_timing):
+        for op in (QueryToolLocators.btn_explain_verbose,
+                   QueryToolLocators.btn_explain_costs,
+                   QueryToolLocators.btn_explain_buffers,
+                   QueryToolLocators.btn_explain_timing):
             btn = self.page.find_by_css_selector(op)
             check = btn.find_element_by_tag_name('i')
             if 'visibility-hidden' not in check.get_attribute('class'):
                 btn.click()
         # click cost button
         cost_btn = self.page.find_by_css_selector(
-            QueryToolLocatorsCss.btn_explain_costs)
+            QueryToolLocators.btn_explain_costs)
         cost_btn.click()
 
         # close explain options
         explain_op.click()
 
         self.page.find_by_css_selector(
-            QueryToolLocatorsCss.btn_explain_analyze).click()
+            QueryToolLocators.btn_explain_analyze).click()
 
         self.page.wait_for_query_tool_loading_indicator_to_disappear()
         self.page.click_tab('Data Output')
 
-        canvas = wait.until(EC.presence_of_element_located(
-            (By.CSS_SELECTOR, "#datagrid .slick-viewport .grid-canvas"))
+        canvas = self.wait.until(EC.presence_of_element_located(
+            (By.CSS_SELECTOR, QueryToolLocators.query_output_canvas_css))
         )
         # Search for 'Output' word in result (verbose option)
         canvas.find_element_by_xpath("//*[contains(string(), 'JIT')]")
 
-        self._clear_query_tool()
+        self.page.clear_query_tool()
 
     def check_execute_option(self, option):
         """"This function will check auto commit or auto roll back based on
         user input. If button is already checked, no action will be taken"""
         if option == 'auto_commit':
             check_status = self.driver.find_element_by_css_selector(
-                QueryToolLocatorsCss.btn_auto_commit_check_status)
+                QueryToolLocators.btn_auto_commit_check_status)
             if 'visibility-hidden' in check_status.get_attribute('class'):
-                self.page.find_by_css_selector(QueryToolLocatorsCss.
+                self.page.find_by_css_selector(QueryToolLocators.
                                                btn_auto_commit).click()
         if option == 'auto_rollback':
             check_status = self.driver.find_element_by_css_selector(
-                QueryToolLocatorsCss.btn_auto_rollback_check_status)
+                QueryToolLocators.btn_auto_rollback_check_status)
             if 'visibility-hidden' in check_status.get_attribute('class'):
-                self.page.find_by_css_selector(QueryToolLocatorsCss.
+                self.page.find_by_css_selector(QueryToolLocators.
                                                btn_auto_rollback).click()
 
     def uncheck_execute_option(self, option):
@@ -826,15 +763,15 @@ SELECT 1, pg_sleep(300)"""
         user input. If button is already unchecked, no action will be taken"""
         if option == 'auto_commit':
             check_status = self.driver.find_element_by_css_selector(
-                QueryToolLocatorsCss.btn_auto_commit_check_status)
+                QueryToolLocators.btn_auto_commit_check_status)
             if 'visibility-hidden' not in check_status.get_attribute('class'):
-                self.page.find_by_css_selector(QueryToolLocatorsCss.
+                self.page.find_by_css_selector(QueryToolLocators.
                                                btn_auto_commit).click()
         if option == 'auto_rollback':
             check_status = self.driver.find_element_by_css_selector(
-                QueryToolLocatorsCss.btn_auto_rollback_check_status)
+                QueryToolLocators.btn_auto_rollback_check_status)
             if 'visibility-hidden' not in check_status.get_attribute('class'):
-                self.page.find_by_css_selector(QueryToolLocatorsCss.
+                self.page.find_by_css_selector(QueryToolLocators.
                                                btn_auto_rollback).click()
 
 
diff --git a/web/pgadmin/feature_tests/table_ddl_feature_test.py b/web/pgadmin/feature_tests/table_ddl_feature_test.py
index 2537bcfe2..bd9d45fa1 100644
--- a/web/pgadmin/feature_tests/table_ddl_feature_test.py
+++ b/web/pgadmin/feature_tests/table_ddl_feature_test.py
@@ -40,9 +40,13 @@ class TableDdlFeatureTest(BaseFeatureTest):
         self.page.select_tree_item(self.test_table_name)
         self.page.click_tab("SQL")
 
-        self.page.find_by_xpath(
+        # Wait till data is displayed in SQL Tab
+        self.assertTrue(self.page.check_if_element_exist_by_xpath(
             "//*[contains(@class,'CodeMirror-lines') and "
-            "contains(.,'CREATE TABLE public.%s')]" % self.test_table_name)
+            "contains(.,'CREATE TABLE public.%s')]" % self.test_table_name,
+            10), "No data displayed in SQL tab")
 
     def after(self):
         self.page.remove_server(self.server)
+        test_utils.delete_table(
+            self.server, self.test_db, self.test_table_name)
diff --git a/web/pgadmin/feature_tests/view_data_dml_queries.py b/web/pgadmin/feature_tests/view_data_dml_queries.py
index 6152e85ee..a9e9f48ec 100644
--- a/web/pgadmin/feature_tests/view_data_dml_queries.py
+++ b/web/pgadmin/feature_tests/view_data_dml_queries.py
@@ -18,7 +18,8 @@ from selenium.webdriver.common.by import By
 from selenium.webdriver.common.keys import Keys
 from selenium.webdriver.support import expected_conditions as EC
 from selenium.webdriver.support.ui import WebDriverWait
-from .locators import QueryToolLocatorsCss
+from regression.feature_utils.locators import QueryToolLocators, \
+    NavMenuLocators
 
 CURRENT_PATH = os.path.dirname(os.path.realpath(__file__))
 
@@ -26,8 +27,6 @@ config_data = config_data_json = {}
 # try:
 with open(CURRENT_PATH + '/test_data.json') as data_file:
     config_data_json = json.load(data_file)
-# except Exception as e:
-#     print(str(e))
 
 
 class CheckForViewDataTest(BaseFeatureTest):
@@ -121,7 +120,13 @@ CREATE TABLE public.nonintpkey
     def runTest(self):
         self.page.wait_for_spinner_to_disappear()
         self.page.add_server(self.server)
-        self._tables_node_expandable()
+
+        self.page.toggle_open_tree_item(self.server['name'])
+        self.page.toggle_open_tree_item('Databases')
+        self.page.toggle_open_tree_item(self.test_db)
+        self.page.toggle_open_tree_item('Schemas')
+        self.page.toggle_open_tree_item('public')
+        self.page.toggle_open_tree_item('Tables')
 
         self._load_config_data('table_insert_update_cases')
         # iterate on both tables
@@ -134,6 +139,10 @@ CREATE TABLE public.nonintpkey
 
     def after(self):
         self.page.remove_server(self.server)
+        for cnt in (1, 2):
+            test_utils.delete_table(
+                self.server, self.test_db, 'defaults_{0}'.format(str(cnt)))
+        test_utils.delete_table(self.server, self.test_db, 'nonintpkey')
 
     @staticmethod
     def _get_cell_xpath(cell, row):
@@ -227,14 +236,14 @@ CREATE TABLE public.nonintpkey
                     send_keys(Keys.ENTER).perform()
         elif cell_type in ['text', 'json', 'text[]', 'boolean[]']:
             text_area_ele = self.page.find_by_css_selector(
-                ".pg-text-editor > textarea")
+                QueryToolLocators.row_editor_text_area_css)
             text_area_ele.clear()
             text_area_ele.click()
             text_area_ele.send_keys(value)
 
             # Click on editor's Save button
             self.page.find_by_css_selector(
-                '.btn.btn-primary.long_text_editor').click()
+                QueryToolLocators.text_editor_ok_btn_css).click()
         else:
             # Boolean editor test for to True click
             if data[1] == 'true':
@@ -250,24 +259,19 @@ CREATE TABLE public.nonintpkey
                 # Sets false
                 ActionChains(self.driver).click(checkbox_el).perform()
 
-    def _tables_node_expandable(self):
-        self.page.toggle_open_tree_item(self.server['name'])
-        self.page.toggle_open_tree_item('Databases')
-        self.page.toggle_open_tree_item(self.test_db)
-        self.page.toggle_open_tree_item('Schemas')
-        self.page.toggle_open_tree_item('public')
-        self.page.toggle_open_tree_item('Tables')
-
     def _view_data_grid(self, table_name):
         self.page.driver.find_element_by_link_text("Object").click()
         ActionChains(
             self.page.driver
         ).move_to_element(
-            self.page.driver.find_element_by_link_text("View/Edit Data")
+            self.page.driver.find_element_by_link_text(
+                NavMenuLocators.view_data_link_text)
         ).perform()
         self.page.find_by_partial_link_text("All Rows").click()
-        time.sleep(1)
+
         # wait until datagrid frame is loaded.
+        self.page.wait_for_query_tool_loading_indicator_to_appear()
+        self.page.wait_for_query_tool_loading_indicator_to_disappear()
 
         self.page.click_tab(table_name)
 
@@ -284,8 +288,10 @@ CREATE TABLE public.nonintpkey
         row0_cell0_xpath = CheckForViewDataTest._get_cell_xpath("r0", 1)
 
         self.page.find_by_xpath(row0_cell0_xpath).click()
-        self.page.find_by_xpath("//*[@id='btn-copy-row']").click()
-        self.page.find_by_xpath("//*[@id='btn-paste-row']").click()
+        self.page.find_by_css_selector(
+            QueryToolLocators.copy_button_css).click()
+        self.page.find_by_css_selector(
+            QueryToolLocators.paste_button_css).click()
 
         # Update primary key of copied cell
         self._add_update_save_row(config_data['copy'], row=2)
@@ -305,7 +311,7 @@ CREATE TABLE public.nonintpkey
             time.sleep(0.2)
             self._update_cell(cell_xpath, data[str(idx)])
         self.page.find_by_css_selector(
-            QueryToolLocatorsCss.btn_save_data).click()
+            QueryToolLocators.btn_save_data).click()
         # There should be some delay after save button is clicked, as it
         # takes some time to complete save ajax call otherwise discard unsaved
         # changes dialog will appear if we try to execute query before previous
@@ -320,11 +326,12 @@ CREATE TABLE public.nonintpkey
 
     def _verify_messsages(self, text):
         messages_ele = self.page.find_by_css_selector(
-            QueryToolLocatorsCss.query_messages_panel)
+            QueryToolLocators.query_messages_panel)
         self.assertEquals(text, messages_ele.text)
 
     def _verify_row_data(self, is_new_row, config_check_data):
-        self.page.find_by_id("btn-flash").click()
+        self.page.find_by_css_selector(
+            QueryToolLocators.btn_execute_query_css).click()
 
         # First row if row height = 0, second row if its 25
         row_height = 0 if is_new_row else 25
diff --git a/web/pgadmin/feature_tests/xss_checks_panels_and_query_tool_test.py b/web/pgadmin/feature_tests/xss_checks_panels_and_query_tool_test.py
index 049f4f5f2..9b2f31d39 100644
--- a/web/pgadmin/feature_tests/xss_checks_panels_and_query_tool_test.py
+++ b/web/pgadmin/feature_tests/xss_checks_panels_and_query_tool_test.py
@@ -8,10 +8,13 @@
 ##########################################################################
 
 from __future__ import print_function
+import sys
+import random
 from regression.python_test_utils import test_utils
 from regression.feature_utils.base_feature_test import BaseFeatureTest
 from selenium.webdriver import ActionChains
-import sys
+from selenium.common.exceptions import StaleElementReferenceException
+from regression.feature_utils.locators import QueryToolLocators
 
 
 class CheckForXssFeatureTest(BaseFeatureTest):
@@ -32,7 +35,8 @@ class CheckForXssFeatureTest(BaseFeatureTest):
     scenarios = [
         ("Test XSS check for panels and query tool", dict())
     ]
-    test_table_name = "<h1>X"
+    test_table_name = "<h1>X" + str(random.randint(1000, 3000))
+    # test_table_name = "<h1>X"
     test_type_name = '"<script>alert(1)</script>"'
 
     def before(self):
@@ -85,6 +89,8 @@ class CheckForXssFeatureTest(BaseFeatureTest):
 
     def after(self):
         self.page.remove_server(self.server)
+        test_utils.delete_table(
+            self.server, self.test_db, self.test_table_name)
 
     def _tables_node_expandable(self):
         self.page.toggle_open_server(self.server['name'])
@@ -198,7 +204,8 @@ class CheckForXssFeatureTest(BaseFeatureTest):
         self.page.fill_codemirror_area_with(
             "select '<script>alert(1)</script>"
         )
-        self.page.find_by_id("btn-flash").click()
+        self.page.find_by_css_selector(
+            QueryToolLocators.btn_execute_query_css).click()
 
         self.page.click_tab('Query History')
 
@@ -227,13 +234,17 @@ class CheckForXssFeatureTest(BaseFeatureTest):
             '&lt;script&gt;alert(1)&lt;/script&gt;',
             "Query tool (History Details-Message)"
         )
-
-        # Check for history details error message
-        history_ele = self.page.find_by_css_selector(
-            ".query-detail .history-error-text"
-        )
-
-        source_code = history_ele.get_attribute('innerHTML')
+        retry = 2
+        while retry > 0:
+            try:
+                # Check for history details error message
+                history_ele = self.page.find_by_css_selector(
+                    ".query-detail .history-error-text"
+                )
+                source_code = history_ele.get_attribute('innerHTML')
+                break
+            except StaleElementReferenceException:
+                retry -= 1
 
         self._check_escaped_characters(
             source_code,
@@ -272,7 +283,8 @@ class CheckForXssFeatureTest(BaseFeatureTest):
             'select * from "{0}"'.format(self.test_table_name)
         )
 
-        self.page.find_by_id("btn-explain").click()
+        self.page.find_by_css_selector(
+            QueryToolLocators.btn_explain).click()
         self.page.wait_for_query_tool_loading_indicator_to_disappear()
         self.page.click_tab('Explain')
 
diff --git a/web/pgadmin/feature_tests/xss_checks_pgadmin_debugger_test.py b/web/pgadmin/feature_tests/xss_checks_pgadmin_debugger_test.py
index 5f27d97c6..be275913f 100644
--- a/web/pgadmin/feature_tests/xss_checks_pgadmin_debugger_test.py
+++ b/web/pgadmin/feature_tests/xss_checks_pgadmin_debugger_test.py
@@ -88,7 +88,18 @@ class CheckDebuggerForXssFeatureTest(BaseFeatureTest):
 
         # If debugger plugin is not found
         if is_error and is_error.text == "Debugger Error":
-            self.page.click_modal('OK')
+            click = True
+            while click:
+                try:
+                    self.page.click_modal('OK')
+                    wait.until(EC.invisibility_of_element(
+                        (By.XPATH, "//div[contains(@class, 'alertify') and "
+                                   "not(contains(@class, 'ajs-hidden'))]//div["
+                                   "contains(@class,'ajs-header')]")
+                    ))
+                    click = False
+                except TimeoutException:
+                    pass
             self.skipTest(
                 "Please make sure that debugger plugin is properly configured"
             )
diff --git a/web/pgadmin/feature_tests/xss_checks_roles_control_test.py b/web/pgadmin/feature_tests/xss_checks_roles_control_test.py
index 2dac1dde2..6673390a2 100644
--- a/web/pgadmin/feature_tests/xss_checks_roles_control_test.py
+++ b/web/pgadmin/feature_tests/xss_checks_roles_control_test.py
@@ -10,6 +10,10 @@ import random
 
 from regression.python_test_utils import test_utils
 from regression.feature_utils.base_feature_test import BaseFeatureTest
+from regression.feature_utils.locators import NavMenuLocators
+from selenium.webdriver.common.by import By
+from selenium.webdriver.support import expected_conditions as EC
+from selenium.webdriver.support.ui import WebDriverWait
 
 
 class CheckRoleMembershipControlFeatureTest(BaseFeatureTest):
@@ -36,6 +40,7 @@ class CheckRoleMembershipControlFeatureTest(BaseFeatureTest):
                                self.role)
         test_utils.create_role(self.server, "postgres",
                                "<h1>test</h1>")
+        self.wait = WebDriverWait(self.page.driver, 20)
 
     def runTest(self):
         self.page.wait_for_spinner_to_disappear()
@@ -56,9 +61,11 @@ class CheckRoleMembershipControlFeatureTest(BaseFeatureTest):
         self.page.select_tree_item(role)
 
     def _check_role_membership_control(self):
-        self.page.driver.find_element_by_link_text("Object").click()
-        self.page.driver.find_element_by_link_text("Properties...").click()
-        # self.page.find_by_partial_link_text("Membership").click()
+        self.page.driver.find_element_by_link_text(
+            NavMenuLocators.object_menu_link_text).click()
+        property_object = self.wait.until(EC.visibility_of_element_located(
+            (By.CSS_SELECTOR, NavMenuLocators.properties_obj_css)))
+        property_object.click()
         self.click_membership_tab()
         # Fetch the source code for our custom control
         source_code = self.page.find_by_xpath(
diff --git a/web/regression/feature_utils/locators.py b/web/regression/feature_utils/locators.py
new file mode 100644
index 000000000..b2bcb6224
--- /dev/null
+++ b/web/regression/feature_utils/locators.py
@@ -0,0 +1,221 @@
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2019, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+
+class BrowserToolBarLocators():
+    """This will contains element locators for browser tool bar"""
+
+    open_query_tool_button_css = \
+        ".wcFrameButton[title='Query Tool']:not(.disabled)"
+
+    query_tool_panel_css = ".wcPanelTab .wcTabIcon.fa.fa-bolt"
+
+    view_table_data_button_css = \
+        ".wcFrameButton[title='View Data']:not(.disabled)"
+
+    view_data_panel_css = ".wcPanelTab .wcTabIcon.fa.fa-table"
+
+    filter_data_button_css = \
+        ".wcFrameButton[title='Filtered Rows']:not(.disabled)"
+
+    filter_alertify_box_css = ".alertify .ajs-header[data-title~='Filter']"
+
+
+class NavMenuLocators:
+    "This will contains element locators of navigation menu bar"
+
+    file_menu_css = "#mnu_file"
+
+    preference_menu_item_css = "#mnu_preferences"
+
+    tools_menu_link_text = "Tools"
+
+    view_data_link_text = "View/Edit Data"
+
+    object_menu_link_text = "Object"
+
+    properties_obj_css = "#show_obj_properties.dropdown-item:not(.disabled)"
+
+    backup_obj_css = "#backup_object.dropdown-item:not(.disabled)"
+
+    restore_obj_css = "#restore_object.dropdown-item:not(.disabled)"
+
+    maintenance_obj_css = "#maintenance.dropdown-item:not(.disabled)"
+
+    show_system_objects_pref_label_xpath = \
+        "//label[contains(text(), 'Show system objects?')]"
+
+    maximize_pref_dialogue_css = ".ajs-dialog.pg-el-container .ajs-maximize"
+
+    specified_pref_node_exp_status = \
+        "//div[div[span[span[(@class='aciTreeText')and " \
+        "(text()='{0} ' or text()='{0}')]]]]"
+
+    specified_preference_tree_node = \
+        "//div//span[(@class='aciTreeText')and " \
+        "(text()='{0} ' or text()='{0}')]"
+
+    specified_sub_node_of_pref_tree_node = \
+        "//span[text()='{0}']//following::span[text()='{1}']"
+
+    insert_bracket_pair_switch_btn = \
+        "//div[label[normalize-space(text())='Insert bracket pairs?']]" \
+        "//div[contains(@class,'toggle btn')]"
+
+    backup_filename_txt_box_name = "file"
+
+    restore_file_name_txt_box_name = "file"
+
+    backup_btn_xpath = \
+        "//button[contains(@class,'fa-save')and contains(.,'Backup')]"
+
+    bcg_process_status_alertifier_css = \
+        ".ajs-message.ajs-bg-bgprocess.ajs-visible"
+
+    status_alertifier_more_btn_css = ".pg-bg-more-details"
+
+    process_watcher_alertfier = \
+        "//div[contains(@class,'wcFrameTitleBar')]" \
+        "//div[contains(text(),'Process Watcher')]"
+
+    process_watcher_detailed_command_canvas_css = \
+        ".bg-process-details .bg-detailed-desc"
+
+    process_watcher_close_button_xpath = \
+        "//div[contains(@class,'wcFloatingFocus')]//" \
+        "div[contains(@class,'fa-close')]"
+
+    restore_file_name_xpath = "//div[contains(text(),'Restore')]" \
+                              "//following::input[@name='file']"
+
+    restore_button_xpath = \
+        "//button[contains(@class,'fa-upload') and contains(.,'Restore')]"
+
+    maintenance_operation = "//label[text()='Maintenance operation']"
+
+    select_tab_xpath = \
+        "//*[contains(@class,'wcTabTop')]//*[contains(@class,'wcPanelTab') " \
+        "and contains(.,'{}')]"
+
+
+class QueryToolLocators:
+    btn_save_file = "#btn-save-file"
+
+    btn_save_data = "#btn-save-data"
+
+    btn_query_dropdown = "#btn-query-dropdown"
+
+    btn_auto_rollback = "#btn-auto-rollback"
+
+    btn_auto_rollback_check_status = "#btn-auto-rollback > i"
+
+    btn_auto_commit = "#btn-auto-commit"
+
+    btn_auto_commit_check_status = "#btn-auto-commit > i"
+
+    btn_cancel_query = "#btn-cancel-query"
+
+    btn_explain = "#btn-explain"
+
+    btn_explain_analyze = "#btn-explain-analyze"
+
+    btn_explain_options_dropdown = "#btn-explain-options-dropdown"
+
+    btn_explain_verbose = "#btn-explain-verbose"
+
+    btn_explain_costs = "#btn-explain-costs"
+
+    btn_explain_buffers = "#btn-explain-buffers"
+
+    btn_explain_timing = "#btn-explain-timing"
+
+    btn_clear_dropdown = "#btn-clear-dropdown"
+
+    btn_clear_history = "#btn-clear-history"
+
+    btn_clear = "#btn-clear"
+
+    query_editor_panel = "#output-panel"
+
+    query_history_selected = "#query_list .selected"
+
+    query_history_entries = "#query_list>.query-group>ul>li"
+
+    query_history_specific_entry = \
+        "#query_list>.query-group>ul>li:nth-child({})"
+
+    query_history_detail = "#query_detail"
+
+    invalid_query_history_entry_css = "#query_list .entry.error .query"
+
+    editor_panel = "#output-panel"
+
+    query_messages_panel = ".sql-editor-message"
+
+    output_row_xpath = "//div[contains(@class, 'slick-row')][{}]/*[1]"
+
+    output_column_header_css = "[data-column-id='{}']"
+
+    output_column_data_xpath = "//div[contains(@class, 'slick-cell')]" \
+                               "[contains(., '{}')]"
+    output_cell_xpath = "//div[contains(@class, 'slick-cell') and " \
+                        "contains(@class, 'l{0} r{1}')]"
+
+    select_all_column = \
+        "//div[contains(@id,'row-header-column')]"
+
+    new_row_xpath = "//div[contains(@class, 'new-row')]"
+
+    copy_button_css = "#btn-copy-row"
+
+    paste_button_css = "#btn-paste-row"
+
+    row_editor_text_area_css = ".pg-text-editor > textarea"
+
+    text_editor_ok_btn_css = ".btn.btn-primary.long_text_editor"
+
+    btn_load_file_css = "#btn-load-file"
+
+    btn_execute_query_css = "#btn-flash"
+
+    input_file_path_css = "input#file-input-path"
+
+    select_file_content_css = "table#contents"
+
+    query_output_canvas_css = "#datagrid .slick-viewport .grid-canvas"
+
+    query_output_cells = ".slick-cell"
+
+    sql_editor_message = "//div[contains(@class, 'sql-editor-message') and " \
+                         "contains(string(), '{}')]"
+
+    code_mirror_hint_box_xpath = "//ul[@class='CodeMirror-hints default']"
+
+    code_mirror_hint_item_xpath = \
+        "//ul[contains(@class, 'CodeMirror-hints') and contains(., '{}')]"
+
+    code_mirror_data_xpath = "//pre[@class=' CodeMirror-line ']/span"
+
+    save_data_icon = "icon-save-data-changes"
+
+    commit_icon = "icon-commit"
+
+    execute_icon = "fa-bolt"
+
+    explain_icon = "fa-hand-pointer-o"
+
+    explain_analyze_icon = "fa-list-alt"
+
+    query_history_selected_icon = '#query_list .selected #query_source_icon'
+
+    btn_commit = "#btn-commit"
+
+    show_query_internally_btn = \
+        "//div[label[normalize-space(" \
+        "text())='Show queries generated internally by pgAdmin?']]" \
+        "//div[contains(@class,'toggle btn')]"
